# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class ZoneSettingsOverride(pulumi.CustomResource):
    initial_settings: pulumi.Output[dict]
    """
    Settings present in the zone at the time the resource is created. This will be used to restore the original settings when this resource is destroyed. Shares the same schema as the `settings` attribute (Above).
    """
    initial_settings_read_at: pulumi.Output[str]
    name: pulumi.Output[str]
    """
    The DNS zone to which apply settings.
    """
    readonly_settings: pulumi.Output[list]
    """
    Which of the current `settings` are not able to be set by the user. Which settings these are is determined by plan level and user permissions.
    * `zone_status`. A full zone implies that DNS is hosted with Cloudflare. A partial zone is typically a partner-hosted zone or a CNAME setup.
    * `zone_type`. Status of the zone. Valid values: active, pending, initializing, moved, deleted, deactivated.
    """
    settings: pulumi.Output[dict]
    """
    Settings overrides that will be applied to the zone. If a setting is not specified the existing setting will be used. For a full list of available settings see below.
    """
    zone_status: pulumi.Output[str]
    zone_type: pulumi.Output[str]
    def __init__(__self__, resource_name, opts=None, name=None, settings=None, __name__=None, __opts__=None):
        """
        Provides a resource which customizes Cloudflare zone settings. Note that after destroying this resource Zone Settings will be reset to their initial values.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: The DNS zone to which apply settings.
        :param pulumi.Input[dict] settings: Settings overrides that will be applied to the zone. If a setting is not specified the existing setting will be used. For a full list of available settings see below.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-cloudflare/blob/master/website/docs/r/zone_settings_override.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if name is None:
            raise TypeError("Missing required property 'name'")
        __props__['name'] = name

        __props__['settings'] = settings

        __props__['initial_settings'] = None
        __props__['initial_settings_read_at'] = None
        __props__['readonly_settings'] = None
        __props__['zone_status'] = None
        __props__['zone_type'] = None

        if opts is None:
            opts = pulumi.ResourceOptions()
        if opts.version is None:
            opts.version = utilities.get_version()
        super(ZoneSettingsOverride, __self__).__init__(
            'cloudflare:index/zoneSettingsOverride:ZoneSettingsOverride',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

